﻿/**
 * GAINER flash libray
 * @author PDP Project
 * @version 1.0
 */

import gainer.*;

class gainer.Servo {
	private var _gainer:Gainer;
	public var numOutCh:Number = 8;
	
	function Servo(_gainer:Gainer) {
		this._gainer = _gainer;
	}
	
	public function configuration(nOut:Number):Void {
  		numOutCh = nOut;
  	}
	
	//指定したチャンネルへ送信
  	public function out(ch:Number,value:Number):Void {
		if(typeof(ch) == "number") {
			if(numOutCh>ch){
				var s:String = "p" + ch.toString(16).toUpperCase();
				value = Math.floor(value);
				value = value<  0 ?   0: value;
				value = value>255 ? 255: value;
					
				var sv:String = value<16 ? "0": "";
				sv+= value.toString(16).toUpperCase();
				s+=sv;
				s+="*";
				_gainer.enqueue(new SynchronizedGC(_gainer, s, "p"));
			}else{
				trace("Gainer error!! out of bounds servo out");
			}
		} else if(ch instanceof Array) {
			var values = ch;
		
			var s:String = "P";
			var sv:String = "";
			if(numOutCh==values.length){
				for(var i=0;i<values.length;i++){
					values[i] = Math.floor(values[i]);
					values[i] = values[i]<  0 ?   0: values[i];
					values[i] = values[i]>255 ? 255: values[i];
					sv = values[i]<16 ? "0": "";
					sv+= values[i].toString(16).toUpperCase();
					s+=sv;
				}
			  s+= "*";
			}else{
				trace("Gainer error!! - number of servo outputs are wrong");
			}
			_gainer.enqueue(new SynchronizedGC(_gainer, s, "P"));
		}
 	 }
}